import { BaseURI, RewardsFactoryError, ECreatedRewardType, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { Provider, ContractFactory, Wallet } from "zksync-web3";
import { BaseContract } from "../../implementations/BaseContract.js";
import { ContractOverrides, IRewardsContractFactory } from "../../interfaces/index.js";
import { WrappedTransactionResponse } from "../../interfaces/objects/index.js";
export declare class ZkSyncRewardsContractFactory extends BaseContract<RewardsFactoryError> implements IRewardsContractFactory {
    protected providerOrSigner: Provider | Wallet;
    protected rewardType: ECreatedRewardType;
    protected contractFactory: ContractFactory;
    protected rewardTypeToDeploy: ECreatedRewardType;
    constructor(providerOrSigner: Provider | Wallet, //SEANCHARLIE : needs to use ZkSync provider and wallet
    rewardType: ECreatedRewardType);
    deployERC721Reward(name: string, symbol: string, baseURI: BaseURI, overrides: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | RewardsFactoryError>;
    estimateGasToDeployERC721Contract(name: string, symbol: string, baseURI: BaseURI): ResultAsync<ethers.BigNumber, RewardsFactoryError | BlockchainCommonErrors>;
    protected generateContractSpecificError(msg: string, reason: string | undefined, e: unknown): RewardsFactoryError;
    protected writeToContractFactory(functionName: string, functionParams: any[], overrides?: ContractOverrides, isDeployingContract?: boolean): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | RewardsFactoryError>;
}
//# sourceMappingURL=ZkSyncRewardsContractFactory.d.ts.map